function [DA,SDA,DA_Checked]=Drainage_Area(FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,INan,ZT,nrows,ncols,cellsize)

%Drainage area
%%%%%%%%%                     %%
%        %%                  %% %%
%         %%                %%   %%
%          %%              %%     %%
%           %%            %%       %%
%            %%          %%         %%
%            %%         %%           %%
%             %%       %%%%%%%%%%%%%%%%%
%             %%      %%               %%
%             %%     %%                 %%
%             %%    %%                   %%
%            %%    %%                     %%
%%%%%%%%%%%%%     %%                       %%
nn=0;
LP=1;
tr_comp=zeros(1);
tc_comp=zeros(1);
% identify nans
%INan = isnan(FP8);
% set nans to 0

FP8(INan) = 0;
FP1(INan) = 0;
FP2(INan) = 0;
FP3(INan) = 0;
FP4(INan) = 0;
FP5(INan) = 0;
FP6(INan) = 0;
FP7(INan) = 0;


while LP>0;


%ZNAN = isnan(ZT);
DA_Checked=zeros(nrows,ncols);
DA_Checked(INan)= NaN;
%DA_Checked(isnan(Classification_matrix))= 1;
%DA=Drainage area
DA=zeros(nrows,ncols);
DA=DA + (cellsize)^2;
%DA(INan)= NaN;
%SDA Specific drainage area
SDA=zeros(nrows,ncols);
SDA=SDA + cellsize;
%SDA(INan)= NaN;
%
n=sum(sum(DA_Checked == 0));
full_matrix_loop=0;

while n >0
for r=2:nrows-1
for c=2:ncols-1
        if DA_Checked(r,c) == 0 %if current point is unchecked
% check each cell around current cell should have no flow to the current
% cell OR it should be checked then we can divid the flow from this cell to
% all other 8 cells around
           %%%%%%%%%%%%%%%%%%%
          %%%%%%%%%%%%%%%%%%%%%%%%%555
           if r==1 && c==1
          
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           if FP8(r+1,c+1)==0 || DA_Checked(r+1,c+1) == 1
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1
               
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
      ww=1;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
     
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c))*DA(r,c)/100;
      DA(r+1,c+1)=DA(r+1,c+1) + (FP4(r,c))*DA(r,c)/100;
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c))*DA(r,c)/100;
     %
     SDA(r,c+1)=SDA(r,c+1)+ ((FP3(r,c))*DA(r,c))/(100*(cellsize));
     SDA(r+1,c+1)=SDA(r+1,c+1)+ ((FP4(r,c))*DA(r,c))/(100*(cellsize));
     SDA(r+1,c)= SDA(r+1,c)+ ((FP5(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
                           
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           if r==1 && c==ncols
                      
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1
           if FP2(r+1,c-1)==0 || DA_Checked(r+1,c-1) == 1
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
       ww=2;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
           
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c))*DA(r,c)/100;
      DA(r+1,c-1)=DA(r+1,c-1) + (FP6(r,c))*DA(r,c)/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c))*DA(r,c)/100;
       %
      SDA(r+1,c)=SDA(r+1,c)+((FP5(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c-1)=SDA(r+1,c-1)+((FP6(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
               
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%
           if r==nrows && c==1
             
           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           if FP6(r-1,c+1)==0 || DA_Checked(r-1,c+1) == 1
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           
    
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
       ww=3;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      
      DA(r-1,c)=DA(r-1,c) + (FP1(r,c))*DA(r,c)/100;
      DA(r-1,c+1)=DA(r-1,c+1) + (FP2(r,c))*DA(r,c)/100;
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c))*DA(r,c)/100;
     %
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c+1)=SDA(r-1,c+1)+((FP2(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c+1)=SDA(r,c+1)+((FP3(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end  
               
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           if r==nrows && c==ncols
           if FP4(r-1,c-1)==0 || DA_Checked(r-1,c-1) == 1
           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
      ww=4;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      DA(r-1,c-1)=DA(r-1,c-1) + (FP8(r,c))*DA(r,c)/100;
      DA(r-1,c)=DA(r-1,c) + (FP1(r,c))*DA(r,c)/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c))*DA(r,c)/100;
      %
      SDA(r-1,c-1)=SDA(r-1,c-1)+((FP8(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end  
               
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           
           
           
           
           
           if r==1 && c>1 && c<ncols
                      
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           if FP8(r+1,c+1)==0 || DA_Checked(r+1,c+1) == 1
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1
           if FP2(r+1,c-1)==0 || DA_Checked(r+1,c-1) == 1
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
      %DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
      ww=5;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c))*DA(r,c)/100;
      DA(r+1,c+1)=DA(r+1,c+1) + (FP4(r,c))*DA(r,c)/100;
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c))*DA(r,c)/100;
      DA(r+1,c-1)=DA(r+1,c-1) + (FP6(r,c))*DA(r,c)/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c))*DA(r,c)/100;
      %
      SDA(r,c+1)=SDA(r,c+1)+((FP3(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c+1)=SDA(r+1,c+1)+((FP4(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c)=SDA(r+1,c)+((FP5(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c-1)=SDA(r+1,c-1)+((FP6(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
           end
           end   
               
           end
           %%%%%%%%%%%%%%%%%%%%%%%
           
           
           %%%%%%%%%%%%%%%%%%%%%%
           if r==nrows && c>1 && c<ncols
             
           if FP4(r-1,c-1)==0 || DA_Checked(r-1,c-1) == 1
           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           if FP6(r-1,c+1)==0 || DA_Checked(r-1,c+1) == 1
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
       ww=6;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      DA(r-1,c-1)=DA(r-1,c-1) + (FP8(r,c))*DA(r,c)/100;
      DA(r-1,c)=DA(r-1,c) + (FP1(r,c))*DA(r,c)/100;
      DA(r-1,c+1)=DA(r-1,c+1) + (FP2(r,c))*DA(r,c)/100;
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c))*DA(r,c)/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c))*DA(r,c)/100;
      %
      SDA(r-1,c-1)=SDA(r-1,c-1)+((FP8(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c+1)=SDA(r-1,c+1)+((FP2(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c+1)=SDA(r,c+1)+((FP3(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
           end
           end  
               
           end
            %%%%%%%%%%%%%%%%%%%%%%%%
           
            
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           if c==1 && r>1 && r<nrows
             

           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           if FP6(r-1,c+1)==0 || DA_Checked(r-1,c+1) == 1
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           if FP8(r+1,c+1)==0 || DA_Checked(r+1,c+1) == 1
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1

    
    
      %DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
       ww=7;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around

      DA(r-1,c)=DA(r-1,c) + (FP1(r,c))*DA(r,c)/100;
      DA(r-1,c+1)=DA(r-1,c+1) + (FP2(r,c))*DA(r,c)/100;
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c))*DA(r,c)/100;
      DA(r+1,c+1)=DA(r+1,c+1) + (FP4(r,c))*DA(r,c)/100;
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c))*DA(r,c)/100;
      %
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c+1)=SDA(r-1,c+1)+((FP2(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c+1)=SDA(r,c+1)+((FP3(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c+1)=SDA(r+1,c+1)+((FP4(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c)=SDA(r+1,c)+((FP5(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
           end
           end  
               
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           
           
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%
           if c==ncols && r>1 && r<nrows
            
           if FP4(r-1,c-1)==0 || DA_Checked(r-1,c-1) == 1
           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1
           if FP2(r+1,c-1)==0 || DA_Checked(r+1,c-1) == 1
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
      %DA(r,c)= DA(r,c)+ (cellsize)^2;
      DA_Checked(r,c) = 1;
      
      ww=8;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      DA(r-1,c-1)=DA(r-1,c-1) + (FP8(r,c))*DA(r,c)/100;
      DA(r-1,c)=DA(r-1,c) + (FP1(r,c))*DA(r,c)/100;
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c))*DA(r,c)/100;
      DA(r+1,c-1)=DA(r+1,c-1) + (FP6(r,c))*DA(r,c)/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c))*DA(r,c)/100;
      %
      SDA(r-1,c-1)=SDA(r-1,c-1)+((FP8(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c)=SDA(r+1,c)+((FP5(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c-1)=SDA(r+1,c-1)+((FP6(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
           end
           end
           end
           end
           end   
           end
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%

 if r>1 && r<nrows && c>1 && c<ncols

           if FP4(r-1,c-1)==0 || DA_Checked(r-1,c-1) == 1
           if FP5(r-1,c)==0 || DA_Checked(r-1,c) == 1
           if FP6(r-1,c+1)==0 || DA_Checked(r-1,c+1) == 1
           if FP7(r,c+1)==0 || DA_Checked(r,c+1) == 1
           if FP8(r+1,c+1)==0 || DA_Checked(r+1,c+1) == 1
           if FP1(r+1,c)==0 || DA_Checked(r+1,c) == 1
           if FP2(r+1,c-1)==0 || DA_Checked(r+1,c-1) == 1
           if FP3(r,c-1)==0 || DA_Checked(r,c-1) == 1
    
    
     % DA(r,c)= DA(r,c)+ (cellsize)^2; 
      DA_Checked(r,c) = 1;
      ww=9;
      n=n-1;

      % Divide the flow from current cell to the 8 cells around
      DA(r-1,c-1)=DA(r-1,c-1) + (FP8(r,c)*DA(r,c))/100;
      DA(r-1,c)=DA(r-1,c) + (FP1(r,c)*DA(r,c))/100;
      DA(r-1,c+1)=DA(r-1,c+1) + (FP2(r,c)*DA(r,c))/100;
      DA(r,c+1)=DA(r,c+1) + (FP3(r,c)*DA(r,c))/100;
      DA(r+1,c+1)=DA(r+1,c+1) + (FP4(r,c)*DA(r,c))/100;
      DA(r+1,c)=DA(r+1,c) + (FP5(r,c)*DA(r,c))/100;
      DA(r+1,c-1)=DA(r+1,c-1) + (FP6(r,c)*DA(r,c))/100;
      DA(r,c-1)=DA(r,c-1) + (FP7(r,c)*DA(r,c))/100;
      
      %
      SDA(r-1,c-1)=SDA(r-1,c-1)+((FP8(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c)=SDA(r-1,c)+((FP1(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r-1,c+1)=SDA(r-1,c+1)+((FP2(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c+1)=SDA(r,c+1)+((FP3(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c+1)=SDA(r+1,c+1)+((FP4(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c)=SDA(r+1,c)+((FP5(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r+1,c-1)=SDA(r+1,c-1)+((FP6(r,c))*DA(r,c))/(100*(cellsize));
      SDA(r,c-1)=SDA(r,c-1)+((FP7(r,c))*DA(r,c))/(100*(cellsize));
      
           end
           end
           end
           end
           end
           end
           end
           end
%    DA
%   
%    (FP8(r,c))*DA(r,c)/100
%    (FP1(r,c))*DA(r,c)/100
%    (FP2(r,c))*DA(r,c)/100
%    (FP3(r,c))*DA(r,c)/100
%    (FP4(r,c))*DA(r,c)/100
%    (FP5(r,c))*DA(r,c)/100
%    (FP6(r,c))*DA(r,c)/100
%    (FP7(r,c))*DA(r,c)/100
%    r
%    c
%    n
         
 end 
 
        end
      
end %end ncols
end %end nrows
      nnn=nn-n
      LP=n;
      if nnn == 0
        n=0;
      end

full_matrix_loop=full_matrix_loop+1;
nn=n;
end % end of DA1

%end of function

%end check
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%Sink remove stage 2
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%We have loops , lakes and sinks
%
%change one cell in every loop to sink
LP

if LP>0
   
%[FP8,FP1,FP2,FP3,FP4,FP5,FP6,FP7,DA_Checked]=FLAT_Flow(FP8,FP1,FP2,FP3,FP4,FP5,FP6,FP7,DA_Checked,ZT,nrows,ncols);
tr_comp2=tr_comp;
tc_comp2=tc_comp;
pause
[FP8,FP1,FP2,FP3,FP4,FP5,FP6,FP7,tr_comp,tc_comp]=loops2sinks(FP8,FP1,FP2,FP3,FP4,FP5,FP6,FP7,ZT,DA_Checked,nrows,ncols);


[ncompl]=size(tr_comp);
[ncomp2]=size(tr_comp2);

tr_comp;
tc_comp;
%%%%%%%%%%%%%%%%%%%%%%5
if ncompl==ncomp2
if tr_comp2==tr_comp 
       LP=0; 
end
end 
 
 
 
%end
end

end %end while LP>0
% DA(DA==0)=NaN;
% SDA(SDA==0)=NaN;
% FP8(INan) = NaN;
% FP1(INan) = NaN;
% FP2(INan) = NaN;
% FP3(INan) = NaN;
% FP4(INan) = NaN;
% FP5(INan) = NaN;
% FP6(INan) = NaN;
% FP7(INan) = NaN;