%Matlab function to read a DEM file
%Abdulghani 2009-11-4
function [ncols,nrows,xllcorner,yllcorner,cellsize,NODATA_value,Z]=Reading(input_file_path)

fid(1)= fopen(input_file_path,'r'); %open DEM ASCII file for reading
%
%Read DEM heading
InputText=textscan(fid(1),'ncols %f',1); % Read parameter value
ncols=InputText{1};
InputText=textscan(fid(1),'nrows %f',1); % Read parameter value
nrows=InputText{1};
InputText=textscan(fid(1),'xllcorner %f',1); % Read parameter value
xllcorner=InputText{1};
InputText=textscan(fid(1),'yllcorner %f',1); % Read parameter value
yllcorner=InputText{1};
InputText=textscan(fid(1),'cellsize %f',1); % Read parameter value
cellsize=InputText{1};
InputText=textscan(fid(1),'NODATA_value %f',1); % Read parameter value
NODATA_value=InputText{1};
%
%Reading elevation data
InputText1=textscan(fid(1), ' %f','delimiter',','); % Read data block
Z=cell2mat(InputText1); % Convert the text to numerical array (data) 
%Z(Z == NODATA_Value)=NaN; %Assign NaN to all NODATA_Value cells
fclose(fid(1));
%end of function