%Matlab function to write a grid file in a DEM format
%Abdulghani 2009-11-4
function [done]=Writing(output_file_path,ncols,nrows,xllcorner,yllcorner,cellsize,NODATA_value,THEMATRIX)

fid(5)= fopen(output_file_path,'w');%path to save the file
%writing heading
fprintf(fid(5),'ncols %d',ncols);
fprintf(fid(5),'\n');
fprintf(fid(5),'nrows %d',nrows);
fprintf(fid(5),'\n');
fprintf(fid(5),'xllcorner %f',xllcorner);
fprintf(fid(5),'\n');
fprintf(fid(5),'yllcorner %f',yllcorner);
fprintf(fid(5),'\n');
fprintf(fid(5),'cellsize %d',cellsize);
fprintf(fid(5),'\n');
fprintf(fid(5),'NODATA_value %f',NODATA_value);
fprintf(fid(5),'\n');
%
%writing the data to file
THEMATRIX(isnan(THEMATRIX)) = NODATA_value;%changing NaNs to NODATA_Value
for r = 1:nrows
  for c = 1:ncols  
fprintf(fid(5),'% 10.3f',THEMATRIX(r,c)); %note the format 10.3f
%depnding on the numbers one can use small format to minimize the size of
%the file on disk
%:::::::::::::::::::::::::::::::::::::::::::::
 end
fprintf(fid(5),'\n');
 end
fclose(fid(5));
done='The writing of file is now complete';
%end of function